; solving equation ax^2 + bx + c = 0

	INCLUDE EFR32MG12.inc		; CPU register definitions
	EXPORT	main	
	
;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code

	OORW	(0xF << 20), 0, CPACR	; enable FPU
	dsb				; sata synch barrier

	ldr	R0, =a
	ldr	R1, [R0]		; R1 = a
	ldr	R2, [R0, #4]		; R2 = b
	ldr	R3, [R0, #8]		; R3 = c
	push	{R1 - R3}		; pass params
	bl	Solver
	
	nop

loop	b	loop			; repeat periodic task		
	ENDP

;-------------------------------------
Solver	PROC				; takes a,b,c in stack; returns S0,S1
	push	{R10}
	mov	R10, SP			; compose stack frame
	vpush.f	{S2 - S7}		; save used regs	
	vldr.f	S2, [R10, #4]		; S2 = a
	vldr.f	S3, [R10, #8]		; S3 = b
	vldr.f	S4, [R10, #12]		; S4 = c
	
	vmul.f	S5, S3, S3		; S5 = b*b
	vmul.f	S6, S2, S4		; S6 = a*c
	vmov.f	S7, #4
;	vldr.f	S7, =4.0
	vmls.f	S5, S6, S7		; S5 = b*b - 4*ac
	vsqrt.f	S5, S5			; S5 = sqrt(b*b - 4*ac)
	vmov.f	S7, #2	
	vmul.f	S7, S7, S2		; S7 = 2*a
	vsub.f	S0, S5, S3		; S0 = numerator
	vdiv.f	S0, S7			; S0 = x_1
	
	vneg.f	S5, S5			; S5 = -sqrt(b*b - 4*ac)
	vsub.f	S1, S5, S3		; S1 = numerator
	vdiv.f	S1, S7			; S1 = x_2
	
	vpop.f	{S2 - S7}		; restore used regs
	pop	{R10}
	add	SP, #12
	bx	LR			; return	
	
;	vpop.f	{S2-S4}	
	
	bx	LR
	ENDP
		
;-------------------------------------
	ALIGN
a	DCFS	1.5
b	DCFS	1
c	DCFS	2

	ALIGN
	END
	